//
//  BIPDFInvoiceGenerator.h
//  BIReports
//
//  Created by Alykhan Jetha on 10-05-13.
//  Copyright 2010 Marketcircle, Inc. All rights reserved.
//

#import "BIPDFDocumentGenerator.h"

@class MCPDatabaseObjectContext;
@class BIRecurringInvoice;

@interface BIPDFInvoiceGenerator : BIPDFDocumentGenerator {
	BIRecurringInvoice *recurringInvoice;
}

@property (retain) BIRecurringInvoice *recurringInvoice;

/*!
 
 {
 	Invoice =     {
 		createDate = "2010-05-31 20:56:11 -0400";
 		discount = 0;
 		dueDate = "2010-06-30 20:56:11 -0400";
 		invoiceDate = "2010-05-31 20:56:11 -0400";
 		invoiceNumber = 121;
 		markup = 0;
 		modifyDate = "2010-05-31 20:56:14 -0400";
 		name = "";
 		sentDate = "2010-05-31 20:56:11 -0400";
 		state = 102;
 	};
 	OrderedSlips =     (
 		10,
 		9,
 		8
 	);
 	clientID = 9;
 	customizations =     {
		HeaderText = Invoice;
 		ProFormaHeaderText = "Pro Forma Invoice";
 		ProFormaInvoiceNumberText = " ";
 		SlipDateTypeCode = 1;
 		WantsHeaderText = 1;
 		WantsPreviousBalance = 1;
 		WantsProjectName = 1;
 		WantsSlipComment = 0;
 		WantsSlipDate = 0;
 		WantsSlipPrice = 1;
 		WantsSlipProject = 0;
 		WantsSlipQuantity = 1;
 		WantsSlipTax = 1;
 		WantsSlipWorker = 0;
 		WantsTaxRegistration = 1;
 		WantsTotalTaxes = 1;
 		WantsBankingInfo = 1;
 	};
 	isPreview = 1;
 	templateName = "Airmail Invoice";
 	type = Invoice;
 	wantsEmbededStorage = 1;
 }
 
 */
- (id)initWithInvoiceRepresentation:(NSDictionary *)invRep objectContext:(MCPDatabaseObjectContext *)oc;

- (BOOL)isRecurring;

@end
