//
//  BPAuthenticationStringFormatter.h
//  BISubstrate
//
//  Created by Alykhan Jetha on 10-09-20.
//  Copyright 2010 Marketcircle, Inc. All rights reserved.
//

#import <MCFoundation/MCStringFormatter.h>


/*!
 This class exists because MCStringFormatter behaves incorrectly when there are invalid characters in the string. Instead of warnign the user of the invalid characters, it just strips them away without warning the user. The result of which is the user things they entered a certain password or username but infact the system records a different one.
 */
@interface BPAuthenticationStringFormatter : NSFormatter {
	NSMutableCharacterSet *characters;
}

/*!
 Subclassers can create their own valid set
 */
- (void)buildCharacterSet:(NSMutableCharacterSet *)aCharSet;

@end
