//
//  NSAttributedString+BIAdditions.h
//  BIViews
//
//  Created by Fraser Kuyvenhoven on 29/05/08.
//  Copyright 2008 Marketcircle. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface NSAttributedString (BIAdditions)

// Account List

+ (NSMutableDictionary *)biAttributesForAccountListItemName;
+ (NSMutableDictionary *)biAttributesForAccountListItemDate;
+ (NSMutableDictionary *)biAttributesForAccountListItemAmount;
+ (NSMutableDictionary *)biAttributesForAccountListItemProFormaInvoiceAmount;
+ (NSMutableDictionary *)biAttributesForAccountListInvoiceBalanceAmount;
+ (NSMutableDictionary *)biAttributesForAccountListItemAmountTailIndent;
+ (NSMutableDictionary *)biAttributesForAccountListUnappliedPaymentAmountTailIndent;
+ (NSMutableDictionary *)biAttributesForAccountListActualPaymentAmountTailIndent;
+ (NSMutableDictionary *)biAttributesForAccountListItemRetainerAmount;
+ (NSMutableDictionary *)biAttributesForAccountListItemRetainerAmountTailIndent;
+ (NSMutableDictionary *)biAttributesForAccountListInvoiceResent;
+ (NSMutableDictionary *)biAttributesForAccountListInvoiceUnpaid;
+ (NSMutableDictionary *)biAttributesForAccountListInvoiceOverdue;
+ (NSMutableDictionary *)biAttributesForAccountBalanceValue;
+ (NSMutableDictionary *)biAttributesForAccountBalanceLabel;

// Search Results

+ (NSMutableDictionary *)biAttributesForSearchResultItemName;
+ (NSMutableDictionary *)biAttributesForSearchResultItemDetails;
+ (NSMutableDictionary *)biAttributesForSearchResultItemPath;
+ (NSMutableDictionary *)biAttributesForSearchResultHeaderLabel;

// Misc

+ (NSMutableDictionary *)biAttributesForDragText;
+ (NSMutableDictionary *)biAttributesForWebViewButtonBar;
+ (NSMutableDictionary *)biAttributesForFlatTabBar;
+ (NSMutableDictionary *)biAttributesForFlatTabBarTabs;
+ (NSMutableDictionary *)biAttributesForSlipsSummary;
+ (NSMutableDictionary *)biAttributesForProjectListName;
+ (NSMutableDictionary *)biAttributesForProjectListStatus;
+ (NSMutableDictionary *)biAttributesForTemplateChooser;
+ (NSMutableDictionary *)biAttributesForTemplateChooserSelected;
+ (NSMutableDictionary *)biAttributesForTemplateChooserBadge;
+ (NSMutableDictionary *)biAttributesForSlipsDoneButton;

// Client Info

+ (NSMutableDictionary *)biAttributesForClientInfoTitle;
+ (NSMutableDictionary *)biAttributesForClientInfoInactiveTitle;
+ (NSMutableDictionary *)biAttributesForClientInfoLabels;
+ (NSMutableDictionary *)biAttributesForClientInfoInactiveLabels;
+ (NSMutableDictionary *)biAttributesForClientInfoContent;
+ (NSMutableDictionary *)biAttributesForClientInfoInactiveContent;
+ (NSMutableDictionary *)biAttributesForClientInfoAnimatingRollover;
+ (NSMutableDictionary *)biAttributesForClientInfoInactiveAnimatingRollover;

// Recurring Invoices

+ (NSMutableDictionary *)biAttributesForRecurringInvoiceName;
+ (NSMutableDictionary *)biAttributesForRecurringInvoicePeriod;
+ (NSMutableDictionary *)biAttributesForRecurringInvoiceClient;
+ (NSMutableDictionary *)biAttributesForRecurringInvoiceNextSendDate;
+ (NSMutableDictionary *)biAttributesForRecurringInvoiceNextSendDateDue;
+ (NSMutableDictionary *)biAttributesForRecurringInvoiceAmount;
+ (NSMutableDictionary *)biAttributesForRecurringInvoiceSendButton;

// Source List

+ (NSMutableDictionary *)biAttributesForSourceListItemTextNormal;
+ (NSMutableDictionary *)biAttributesForSourceListItemTextSelected;
+ (NSMutableDictionary *)biAttributesForSourceListItemTextSelectedTigerDark;
+ (NSMutableDictionary *)biAttributesForSourceListNumberBubbleNormal;
+ (NSMutableDictionary *)biAttributesForSourceListNumberBubbleSelected;
+ (NSMutableDictionary *)biAttributesForSourceListNumberBubbleInactive;

// Sync Status Bar (BP)

+ (NSMutableDictionary *)biAttributesForSyncStatusBarButtonText;

//Login window
+ (NSMutableDictionary *)biAttributesForLoginTabButtons;

@end
