//
//  MCAlertNoteSheet.h
//  MCApplication
//
//  Created by Michael Clark on 05/12/05.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "MCWindowController.h"

@interface MCAlertNoteSheet : MCWindowController {
	IBOutlet NSTextView*       noteTextView;
	
	// Sheet specific state
	id      __modalDelegate;
	SEL     __didEndSelector;
	void*   __contextInfo;
}

+ (MCAlertNoteSheet*)alertNoteSheet;

// didEndSelector should have the following signature:
//   - (void)alertNoteSheetDidEnd: (MCAlertNoteSheet*)sheet returnCode: (int)returnCode contextInfo: (void*)contextInfo
- (void)beginSheetForAlert: (id)alert modalForWindow: (NSWindow*)window modalDelegate: (id)modalDelegate didEndSelector: (SEL)didEndSelector contextInfo: (void*)contextInfo;

- (NSString*)plainTextString;
- (NSData*)rtfString;

- (IBAction)cancel: (id)sender;
- (IBAction)send: (id)sender;

@end
