//
//  MCDuplicateObjectCheckerSheet.h
//  MCApplication
//
//  Created by Eric Hochmeister on 10/4/05.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "MCWindowController.h"

@class MCWebKitTemplateView;
@class MCTableView;

enum
{
    MCDUPLICATEOBJ_NEXTACTION_CANCEL = 990,
    MCDUPLICATEOBJ_NEXTACTION_OK = 991
};

#define MCDUPLICATE_OBJECT_CHECKER_SHEET_EXTEND_POPUP_WIDTH      78.0

@interface MCDuplicateObjectCheckerSheet : MCWindowController {

    NSString* __entityName;
    NSDictionary* __qualifiers;
    NSArray* __nextStepItems;
    NSString* __columnConfigurationIdentifier;
    
    IBOutlet NSPopUpButton* nextStepPopUp;
    IBOutlet NSArrayController* duplicatesController;
    IBOutlet MCTableView* duplicatesTV;
    IBOutlet MCWebKitTemplateView          *webKitTemplateView;
    
    IBOutlet NSButton* okButton;
    IBOutlet NSButton* cancelButton;
    
}

- (NSArrayController*)duplicatesController;
- (NSDictionary *)qualifiers;

- (void)setupSheetWithDictionary:(NSDictionary*)setupDict;
- (BOOL)checkForDuplicates;

- (IBAction)ok:(id)sender;
- (IBAction)cancel:(id)sender;

- (void)hideCancelButton:(BOOL)aFlag;

@end
