//
//  MCGradientColor.h
//  MCApplication
//
//  Created by Ali Lalani on 27/12/05.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@interface MCGradientColor : NSObject {
	NSColor *_color1;
	NSColor *_color2;

	BOOL _isHorizontal;
}
+ (MCGradientColor *)gradientColorWithTopColor:(NSColor *)top bottomColor:(NSColor *)bottom;
+ (MCGradientColor *)gradientColorWithLeftColor:(NSColor *)left rightColor:(NSColor *)right;

+ (MCGradientColor *)defaultGradientColor;
+ (MCGradientColor *)grayGradientColor;

+ (MCGradientColor *)systemGradientColor; // aqua/graphite
+ (MCGradientColor *)lightSystemGradientColor;

+ (MCGradientColor *)aquaGradientColor;
+ (MCGradientColor *)lightAquaGradientColor;
+ (MCGradientColor *)graphiteGradientColor;
+ (MCGradientColor *)lightGraphiteGradientColor;

+ (MCGradientColor *)redGradientColor;
+ (MCGradientColor *)greenGradientColor;

#pragma mark Accessors
- (NSColor *)color1;
- (void)setColor1:(NSColor *)aColor1;
- (NSColor *)color2;
- (void)setColor2:(NSColor *)aColor2;
- (BOOL)isHorizontal;
- (void)setIsHorizontal:(BOOL)flag;
@end
