//
//  MCIntermediaryObjectPickerViewProtocol.h
//  MCApplication
//
//  Created by Ali Lalani on 26/11/05.
//  Copyright 2005 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@protocol MCIntermediaryObjectPickerView <NSObject>
- (id)document;
- (void)setDocument:(id)aDoc;
- (id)targetObject;
- (void)setTargetObject:(id)target;
- (id)sourceObject;
- (void)setSourceObject:(id)source;
- (void)updateForNewModel;
- (id)commitLink;

// These are meant so that if you want to set the actual intermediary object, changes will be made to it instead
// and no linking will be done since the link is already made, it is only for the purposes of editing the object
- (id)intermediaryObject;
- (void)setIntermediaryObject:(id)obj;

// Editability
- (void)setIsEditable:(BOOL)flag;
- (BOOL)isEditable;

// Delegate
- (void)setDelegate:(id)deleg;
- (id)delegate;

@end
