//
//  MCSingleFieldWindow.h
//  MCApplication
//
//  Created by Michael Clark on Mon Aug 19 2002.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "MCModelEditor.h"

// ModalDelegate's didCompleteSelector should have the following signature:
// - (void)singleFieldWindowDidEnd:(MCSingleFieldWindow *)sheet returnCode:(int)returnCode
// This should be added later!! contextInfo:(void  *)contextInfo;

// New features added:  use the modalDelegate and didCompleteSelector together to circumvent the MCModelEditor behaviour
// With the new settings you can have more fine grain control over how the sheet end!

@interface MCSingleFieldWindow : MCModelEditor {

    IBOutlet NSTextField       *labelTF;
    IBOutlet NSTextField       *valueTF;

    // New sheet ending Ivars
    id          modalDelegate;
    SEL         didCompleteSelector;


}

- (void)setLabel: (NSString *)label;
- (NSString *)label;

- (id)modalDelegate;
- (void)setModalDelegate:(id)aModalDelegate;

- (SEL)didCompleteSelector;
- (void)setDidCompleteSelector:(SEL)aDidCompleteSelector;

- (id) fieldObjectValue;
- (void) setFieldObjectValue: (id)obj_val;
- (NSTextField *)field;
@end
