//
//  NSDocument+MCAdditions.h
//  MCApplication
//
//  Created by Alykhan Jetha on Sun Aug 25 2002.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

#import <AppKit/AppKit.h>

@class MCWindowController;

@interface NSDocument (MCAdditions) 


// Subclasses of NSDocument can implement this method and return a replacement nib name for the given window controller. If this method returns nil or an empty string, then the nib name is not reset. An example usage would be returning a different nib name for the group version versus a different nib name for the personal version. This method is called when the document is set on the window controller.
- (NSString *)nibNameForWindowController:(MCWindowController *)aCtl;

// Returns the first sheet if at least one window controller's window has an attached sheet
- (NSWindow *)firstSheet;

@end
