//
//  MCDateSubstitutionFormatter.h
//  MCFoundation
//
//  Created by Alykhan Jetha on 17/10/06.
//  Copyright 1999-2006 Marketcircle Inc. All rights reserved.
//

/*
 Allow you to put <$myDictionary.date$> like strings in a Date formatted field. Essentially it as long as you have <, >, $ characters in the string, then it does not pass the formatting string to super. For a valid string, you need <$ at the beginning and $> at the end.
 
 Typically you would use this when editing a full property list. To perform the substitution, use performSubstitutionWith: inStringValuesWithStartDelimiter: endDelimiter: as defined in NSMutableDictionary+MCAdditions or NSArray+MCAdditions.
 
 */


#import "MCDateFormatter.h"


@interface MCDateSubstitutionFormatter : MCDateFormatter
{
}
@end
