//
//  MCPCustomSQLQualifier.h
//  MCFoundation
//
//  Created by Alykhan Jetha on Sun Aug 10 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "BDQualifier.h"

/*!
	@class MCPCustomSQLQualifier
	@discussion This class is intended to be subclassed. In your subclass, you must override 
	- appendSQLForRootEntity:(MCPEntity *)entity
		parentQualifier:(BDQualifier *)parentQualifier
		databaseConnection:(MCPDatabaseConnection *)connection 
		tableAliases:(MCPTableAliases *)tableAliases
		whereClause:(NSMutableData *)whereClause
		groupClause:(NSMutableData *)groupClause
		sortClause:(NSMutableData *)sortClause;

	and generate the appropriate SQL. You write your SQL into the whereClause and/or groupClause and/or sortClause.
	
	Example usage:
		mySpecialQual = [[[MCPCustomSQLQualifier alloc] initWithParameters:myParamsDict] autorelease];

*/



@interface MCPCustomSQLQualifier : BDQualifier {
	NSDictionary	*parameters;
}

- (id)initWithParameters:(NSDictionary *)params;

@end
